# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free

Name:           ops4j-pax-url
Summary:        Pax URL handlers
Url:            http://paxurl.ops4j.org/
Version:        1.1.3
Release:        1%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-pax-url-1.1.3.tgz
# svn export http://scm.ops4j.org/repos/ops4j/qa/pax/url-1.1.3/ ops4j-pax-url-1.1.3
# tar czf ops4j-pax-url-1.1.3.tgz ops4j-pax-url-1.1.3/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
#Source3:        ops4j-pax-master-3.1.0.pom
# get it from https://scm.ops4j.org/repos/ops4j/qa/pax/master-3.1.0/pom.xml
#Source4:        ops4j-master-1.0.1.pom
# get it from https://scm.ops4j.org/repos/ops4j/qa/master-1.0.1/pom.xml
#Source5:        ops4j-master-1.0.4.pom
# get it from https://scm.ops4j.org/repos/ops4j/qa/master-1.0.4/pom.xml
#Source6:        ops4j-pax-master-1.10.pom
# get it from https://scm.ops4j.org/repos/ops4j/qa/pax/master-1.10/pom.xml
#Source7:        ops4j-pax-master-3.1.2.pom
# get it from https://scm.ops4j.org/repos/ops4j/qa/pax/master-3.1.2/pom.xml

Patch0:         ops4j-pax-url-pom.patch
Patch1:         ops4j-pax-url-dir-osgi-bnd.patch
Patch2:         ops4j-pax-url-war-osgi-bnd.patch
Patch3:         ops4j-pax-url-wrap-osgi-bnd.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  apache-commons-parent
BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  apache-jar-resource-bundle
BuildRequires:  easymock2
BuildRequires:  junit44

BuildRequires:  ops4j-pax-master

BuildRequires:  bnd1
BuildRequires:  jackson
BuildRequires:  ops4j-base
BuildRequires:  ops4j-pax-swissbox
BuildRequires:  org.osgi.core
BuildRequires:  org.osgi.compendium


Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  bnd1
Requires:  jackson
Requires:  ops4j-base
Requires:  ops4j-pax-swissbox

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
OPS4J Pax URL is a set of URL handlers mainly targeting OSGi
URL Handler Service but which can be used in a standard Java
environment.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Daggregate=true \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.ops4j.pax url %{version} JPP/%{name} url
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url.pom

%add_to_maven_depmap org.ops4j.pax.url pax-url-assembly %{version} JPP/%{name} url-assembly
install -m 644 pax-url-assembly/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-assembly.pom
install -m 644 pax-url-assembly/target/pax-url-assembly-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-assembly-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-cache %{version} JPP/%{name} url-cache
install -m 644 pax-url-cache/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-cache.pom
install -m 644 pax-url-cache/target/pax-url-cache-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-cache-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-classpath %{version} JPP/%{name} url-classpath
install -m 644 pax-url-classpath/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-classpath.pom
install -m 644 pax-url-classpath/target/pax-url-classpath-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-classpath-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-commons %{version} JPP/%{name} url-commons
install -m 644 pax-url-commons/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-commons.pom
install -m 644 pax-url-commons/target/pax-url-commons-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-commons-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-dir %{version} JPP/%{name} url-dir
install -m 644 pax-url-dir/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-dir.pom
install -m 644 pax-url-dir/target/pax-url-dir-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-dir-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-link %{version} JPP/%{name} url-link
install -m 644 pax-url-link/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-link.pom
install -m 644 pax-url-link/target/pax-url-link-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-link-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-maven-commons %{version} JPP/%{name} url-maven-commons
install -m 644 pax-url-maven-commons/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-maven-commons.pom
install -m 644 pax-url-maven-commons/target/pax-url-maven-commons-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-maven-commons-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-mvn %{version} JPP/%{name} url-mvn
install -m 644 pax-url-mvn/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-mvn.pom
install -m 644 pax-url-mvn/target/pax-url-mvn-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-mvn-%{version}.jar

%if 0
%add_to_maven_depmap org.ops4j.pax.url pax-url-mercury %{version} JPP/%{name} url-mercury
install -m 644 pax-url-mercury/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-mercury.pom
install -m 644 pax-url-mercury/target/pax-url-mercury-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-mercury-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-maven %{version} JPP/%{name} url-maven
install -m 644 pax-url-maven/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-maven.pom
install -m 644 pax-url-maven/target/pax-url-maven-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-maven-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-mvnlive %{version} JPP/%{name} url-mvnlive
install -m 644 pax-url-mvnlive/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-mvnlive.pom
install -m 644 pax-url-mvnlive/target/pax-url-mvnlive-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-mvnlive-%{version}.jar
%endif

%add_to_maven_depmap org.ops4j.pax.url pax-url-obr %{version} JPP/%{name} url-obr
install -m 644 pax-url-obr/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-obr.pom
install -m 644 pax-url-obr/target/pax-url-obr-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-obr-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-war %{version} JPP/%{name} url-war
install -m 644 pax-url-war/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-war.pom
install -m 644 pax-url-war/target/pax-url-war-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-war-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.url pax-url-wrap %{version} JPP/%{name} url-wrap
install -m 644 pax-url-wrap/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-url-wrap.pom
install -m 644 pax-url-wrap/target/pax-url-wrap-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/url-wrap-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Tue Jun 21 2011 Ralph Apel <r.apel at r-apel.de> 0:1.1.3-1
- First standalone release
